// #name = FpsHud
// #version = 1.1
// #date = 2001-09-25
// #author = Runar
// #credits = Crunchy, who's things i shamelessly copies
// #email = runar@vsdn.org
// #web = http://www.vsdn.org
// #description = Hud that show frames per second
// #status = Release 2

// exec("scripts/autoexec/fpshud.cs");

if(!isObject(FpsHud))
{
	new ScriptObject(FpsHud)
	{
		class = FpsHud;
		ScheduleId = 0;
		LabelColor = "4 235 105";
		TextColor = "255 255 255";
		Gui = "FpsHudGui";
	};
}

function FpsHud::Setup(%this)
{
	new GuiControlProfile ("fpsHudLabelProfile")
	{
		FontType = "Univers Condensed";
		FontSize = 16;
		fontColor = %this.LabelColor;
		justify = "left";
	};	
	new GuiControlProfile ("fpsHudTextProfile")
	{
		FontType = "Univers Condensed";
		FontSize = 16;
		fontColor = %this.TextColor;
		justify = "right";
	};
}

function FpsHud::Create(%this)
{
	%this.Destroy();

	%x = getWord(hudClusterBack.position, 0)-43-8;
	%y = getWord(hudClusterBack.position, 1);
	
	new ShellFieldCtrl(%this.Gui)
	{
		profile = "GuiChatBackProfile";
		horizSizing = "left";
		vertSizing = "bottom";
		position = %x SPC %y;
		extent = "43 16";
		minExtent = "8 8";
		visible = "1";
		
		new GuiTextCtrl()
		{
			profile = "fpsHudLabelProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "3 0";
			extent = "20 16 ";
			visible = "1";
			text = "FPS:";
		};
	};

	%this.Gui.text = new GuiTextCtrl() {
		profile = "fpsHudTextProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "22 0";
		extent = "20 16 ";
		visible = "1";
	};

	%this.Gui.add(%this.Gui.text);
	playGui.add(%this.Gui);
}

function FpsHud::Update(%this, %none)
{

	if(%this.ScheduleId != 0)
		cancel(%this.ScheduleId);

	if(isObject(%this.Gui))
	{
		%this.Gui.text.setValue(mFloor($fps::real));
		%this.ScheduleId = %this.schedule(1000, Update);
	}
}

function FpsHud::Destroy(%this)
{
	if(%this.ScheduleId != 0)
		cancel(%this.ScheduleId);
	
	if(isObject(%this.Gui))
	{
		playGui.remove(%this.Gui);
		%this.Gui.delete();
	}
}

// Packaged parented functions
package FpsHudPkg
{
	function clientCmdTogglePlayHuds(%val)
	{
		FpsHudGui.setVisible(%val);

		parent::clientCmdTogglePlayHuds(%val);
	}

	function DispatchLaunchMode()
	{
		FpsHud.Setup();

		parent::DispatchLaunchMode();
	}

	function LoadingGui::onWake(%this)
	{
		if (!$FpsHudCreated)
		{
			FpsHud.Create();
			FpsHud.Update();
	
			if (isObject(HudMover))
				hudmover::addhud(FpsHudGui, "FpsHud");

			$FpsHudCreated = true;
		}
	
		parent::onWake(%this);
	}

};

activatePackage(FpsHudPkg);
